#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>


#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

#define BUFSIZE 400
char buff[BUFSIZE];									//размер буфера
int count = BUFSIZE-1;									//размер считываего блока

int nflg, bflg, uflg, vflg,fsti;
int fd;
int newline = 1, spased;
int nlines = 1;


int main(int argc, char *argv[])
{	
	char *arg = 0;								//переменная для прохода про **argv
	int res;								//пихаем в переменную ошибки сист.вызовов
	struct stat st;
	int dev, ino;
	
	while (((--argc) > 0) && ((*(++argv ))[0] == '-')) {
		arg = *argv;
		while(*(++arg) != '\0') {
			switch(*arg) {
				case 'n': {
					nflg++;
					break;
				}
				case 'v': {
					vflg++;
					break;
				}
				case 'b': {
					bflg++;
					break;
				}
				case 'u': {
					setbuf(stdout, (char*)NULL);			
					uflg++;
					break;
				}
				default: {
					fprintf(stderr, "Unknown parameter -%c. Plz try again\n", *arg);
					return 1;
				}
			}
		}
	}
//	printf("n=%d,v=%d,b=%d,u=%d \n",nflg,vflg,bflg,uflg);
	res = fstat( fileno(stdout), &st);
	
	if (res == -1) {
		fprintf(stderr, "1 %s\n", strerror(errno));
		exit(1);
	}
	
	dev = st.st_dev;
	ino = st.st_ino;

	if(argc == 0)
		fsti = 1;	
	
	while ( argc>0 || fsti) {							//начинаем поочереди открывать перечисленные файлы
		printf ("\033[31;5m %s \033[m\n", *argv);	
		if (argv[0][0] == '-' && argv[0][1] == '\0')
			fsti = 1;
		
		if (fsti)
			fd = fileno(stdin);
		else
			fd = open(*(argv++),O_RDONLY);
		if (fd == -1) {
			fprintf(stderr, "1.5 %s\n", strerror(errno));
			exit(1);
		}
		
		res = fstat(fd, &st);
		
		if (res == -1) {
			fprintf(stderr, "2 %s\n", strerror(errno));
			close(fd);
			exit(1);
		}
		
		if((!S_ISBLK(st.st_mode)) && (!S_ISREG(st.st_mode)) && (!S_ISCHR(st.st_mode))) {	//проверка на блочное или символьное устройство
			fprintf(stderr, "Its not a regular file, block or char device\n");
			close(fd);
			exit(1);
		}
		
		if( S_ISREG(st.st_mode) && st.st_dev == dev && st.st_ino==ino ){					//тест для исключения ввода вывода в один файл
			fprintf(stderr, "Error! %s is input and output\n", *(argv-1));
			close(fd);
			exit(1);
		}
		printfile();
		close(fd);	
		argc--;
	}
	return EXIT_SUCCESS;
}

int printfile()
{
	int res = 1;
	int i;
	char *pb;
	int ch, tmp;
	while(res != 0) {
		res = read(fd, &buff, count);
		buff[res] = '\0';
		i = 0;
		
		for(; i<res; i++){
			ch = *(buff+i);
			if(!bflg && nflg && newline) {
				printf("%5d ", nlines++);
			}
			
			if(bflg && newline){
				if (ch == '\n') {
					printf("%c", ch);
					continue;
				}
				else 
					printf("%5d ", nlines++);	
			}
			
			if (ch == '\n')
				newline = 1;
			else
				newline = 0;
			printf("%c", ch);
		}
	}
	printf("\n");
	return 0;
}